<?php // phpcs:ignore WordPress.Files.FileName.InvalidClassFileName
namespace Uncanny_Automator_Pro;

/**
 * Class Add_Acf_Integration
 * @package Uncanny_Automator_Pro
 */
class Add_Acf_Integration {

	/**
	 * Integration code
	 * @var string
	 */
	public static $integration = 'ACF';

	/**
	 * Only load this integration and its triggers and actions if the related plugin is active
	 *
	 * @param $status
	 * @param $plugin
	 *
	 * @return bool
	 */
	public function plugin_active( $status, $plugin ) {
		
		$status = false;
	
		if ( class_exists( 'ACF' ) ) {
			$status = true;
		}
		
		return $status;
	}

	/**
	 * Set the directories that the auto loader will run in
	 *
	 * @param $directory
	 *
	 * @return array
	 */
	public function add_integration_directory_func( $directory ) {

		$directory[] = dirname( __FILE__ ) . '/helpers';
		$directory[] = dirname( __FILE__ ) . '/actions';
		$directory[] = dirname( __FILE__ ) . '/triggers';
		$directory[] = dirname( __FILE__ ) . '/tokens';

		return $directory;
	}

	/**
	 * Register the integration by pushing it into the global automator object
	 */
	public function add_integration_func() {
		
		Automator()->register->integration(
			self::$integration,
			array(
				'name'     => 'ACF',
				'icon_svg' => Utilities::get_integration_icon( 'advanced-custom-fields-icon.svg' ),
			)
		);

	}

}
